*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\LBDD\\LBDD.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Function Main()
*+               Function MainFormOnGotFocus()
*+               Function LabelEventHandler()
*+               Function LabelSetBorder()
*+               Procedure HMG_MoveControlWithCursor()
*+               Procedure Undo_Last()
*+               Procedure Init_Undo()
*+               Procedure MoveAround()
*+               Procedure SbarText()
*+               Function SP_lLBDown()
*+
*+    Reformatted by Click! 2.05.36 on Dec-6-2020 at  9:14 am
*+
*+--------------------------------------------------------------------

#include "hmg.ch"
#include "common.ch"

#define LABEL_NAME 1
#define LABEL_HWND 2

STATIC SP_nOldRow  := 0
STATIC SP_nOldCol  := 0
STATIC SP_cOldName := ""
STATIC SP_cOldCtrl := ""

MEMVAR _HMG_SYSDATA

*+--------------------------------------------------------------------
*+
*+    Function Main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Main()

LOCAL aLabel := { { "LABEL_1", NIL }, ;                               // modify to "LABEL_"
                  { "LABEL_2", NIL }, ;
                  { "LABEL_3", NIL } }
LOCAL n

   DEFINE WINDOW MainForm ;
         WIDTH 800 ;
         HEIGHT 600 ;
         TITLE "Labels DagDrop move" ;
         MAIN ;
         ON GOTFOCUS MainFormOnGotFocus( aLabel )

      DEFINE STATUSBAR PARENT MainForm
         STATUSITEM "Hello" WIDTH 600
         DATE WIDTH 100
         CLOCK WIDTH 100
      END STATUSBAR

      //this labels can get focus and process keyboard/mouse messages
      FOR n := 1 TO LEN( aLabel )
         DEFINE LABEL &( aLabel[ n ] [ LABEL_NAME ] )
            ROW 100 + 55 * ( n - 1 )
            COL 10
            WIDTH 140
            HEIGHT 45
            VALUE "This is " + aLabel[ n ] [ LABEL_NAME ]
            ALIGNMENT Center
            FONTCOLOR BLACK
            BACKCOLOR YELLOW
         END LABEL

         aLabel[ n ] [ LABEL_HWND ] := GetProperty( "MainForm", aLabel[ n ] [ LABEL_NAME ], "HANDLE" )

         EventProcessAllHookMessage( EventCreate( { || LabelEventHandler( aLabel ) }, aLabel[ n ] [ LABEL_HWND ] ), .T. )
      NEXT

      DEFINE LABEL LABEL_4
         ROW 290
         COL 10
         WIDTH 140
         HEIGHT 45
         VALUE "This is standard LABEL"
         ALIGNMENT Center
         FONTCOLOR BLACK
         BACKCOLOR YELLOW
      END LABEL

      DEFINE BUTTON CloseButton
         ROW 10
         COL 10
         WIDTH 140
         HEIGHT 45
         CAPTION "Close"
         ACTION MainForm.RELEASE
         ONGOTFOCUS nil
      END BUTTON
   END WINDOW

   SetFocus( aLabel[ 1 ] [ LABEL_HWND ] )

   ON KEY ESCAPE OF MainForm ACTION Undo_Last()                       // Add Jimmy

   MainForm.CENTER
   MainForm.ACTIVATE

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Function MainFormOnGotFocus()
*+
*+    Called from ( lbdd.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION MainFormOnGotFocus( aLabel )

LOCAL n

   FOR n := 1 TO LEN( aLabel )
      PostMessage( aLabel[ n ] [ LABEL_HWND ], WM_MOUSELEAVE, 0, 0 )
   NEXT

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Function LabelEventHandler()
*+
*+    Called from ( lbdd.prg )   1 - function main()
*+                                   1 - procedure movearound()
*+
*+--------------------------------------------------------------------
*+
FUNCTION LabelEventHandler( aLabel )

LOCAL nHWnd    := EventHWND()
LOCAL nMsg     := EventMSG()
LOCAL nWParam  := EventWPARAM()
LOCAL cControl
LOCAL cForm

STATIC lTracking := .F.
STATIC lRunning  := .F.

   GetControlNameByHandle( nHWnd, @cControl, @cForm )

   DO CASE
      CASE nMsg = WM_LBUTTONUP
         SetFocus( nHWnd )
         SP_lLBDown( .F. )
         // msginfo("WM_LBUTTONUP")

      CASE nMsg = WM_LBUTTONDBLCLK                                    // add before WM_LBUTTONDOWN
         SetFocus( nHWnd )
         SP_lLBDown( .F. )
         // MsgInfo(GetProperty(cForm, cControl, "VALUE"))

      CASE nMsg = WM_LBUTTONDOWN                                      // after WM_LBUTTONDBLCLK
         SetFocus( nHWnd )
         Init_Undo()
         IF lRunning = .F.
            lRunning := .T.
            SP_lLBDown( .T. )
            HMG_MoveControlWithCursor( aLabel )
            lRunning := .F.
         ENDIF

      CASE nMsg = WM_RBUTTONDOWN
         SP_lLBDown( .F. )
         SetFocus( nHWnd )

      CASE nMsg = WM_MOUSEMOVE
         IF !lTracking
            SetProperty( cForm, cControl, "FONTCOLOR", RED )
            SetProperty( cForm, cControl, "FONTBOLD", .T. )
            lTracking := TrackMouseEvent( nHWnd )                     //TME_LEAVE is default flag
         ENDIF

      CASE nMsg = WM_MOUSELEAVE
         SetProperty( cForm, cControl, "FONTCOLOR", BLACK )
         SetProperty( cForm, cControl, "FONTBOLD", .F. )
         lTracking := .F.

   ENDCASE

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Procedure HMG_MoveControlWithCursor()
*+
*+    Called from ( lbdd.prg )   1 - function labeleventhandler()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE HMG_MoveControlWithCursor( aLabel )

LOCAL hWnd, nCol, nRow
LOCAL cFormName, cControlName
   GetCursorPos( @nCol, @nRow )
   hWnd := WindowFromPoint( nCol, nRow )
   IF GetControlIndexByHandle( hWnd ) > 0
      GetControlNameByHandle( hWnd, @cControlName, @cFormName )

      IF "LABEL_" $ cControlName                                      // only "LABEL_"
         // save for undo
         SP_cOldName := cFormName
         SP_cOldCtrl := cControlName
         SP_nOldRow = GetProperty( cFormName, cControlName, "Row" )
         SP_nOldCol := GetProperty( cFormName, cControlName, "Col" )

         DoMethod( cFormName, cControlName, "SetFocus" )

#IFDEF Original
         HMG_InterActiveMove( hWnd )
#ELSE
         MoveAround( cFormName, cControlName, hWnd, aLabel )
#ENDIF
         nCol := GetWindowCol( hWnd )
         nRow := GetWindowRow( hWnd )
         ScreenToClient( GetFormHandle( cFormName ), @nCol, @nRow )
         SetProperty( cFormName, cControlName, "Col", nCol )
         SetProperty( cFormName, cControlName, "Row", nRow )
      ENDIF
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure Undo_Last()
*+
*+    Called from ( lbdd.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Undo_Last()

   IF !EMPTY( SP_cOldName ) .AND. !EMPTY( SP_cOldCtrl ) .AND. !EMPTY( SP_nOldRow ) .AND. !EMPTY( SP_nOldCol )
      SetProperty( SP_cOldName, SP_cOldCtrl, "Row", SP_nOldRow )
      SetProperty( SP_cOldName, SP_cOldCtrl, "Col", SP_nOldCol )

      Init_Undo()
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure Init_Undo()
*+
*+    Called from ( lbdd.prg )   1 - function labeleventhandler()
*+                                   1 - procedure undo_last()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Init_Undo()

   SP_nOldRow := 0
   SP_nOldCol := 0
   SP_cOldName := ""
   SP_cOldCtrl := ""
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure MoveAround()
*+
*+    Called from ( lbdd.prg )   1 - procedure hmg_movecontrolwithcursor()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE MoveAround( cFormName, cControlName, hWnd, aLabel )

LOCAL nIndex    := EventCreate( { || LabelEventHandler( aLabel ) }, hWnd )
LOCAL nCol, nRow, nX := 0, nY := 0, nKey := 0
LOCAL nNoThread

   // NEED ?!
*   EventProcessAllHookMessage( nIndex, .T. )

   DO WHILE .T.
      IF SP_lLBDown() = .F.
         EXIT
      ENDIF
      GetCursorPos( @nCol, @nRow )
      IF nY <> nCol .OR. nX <> nRow
         nY := nCol
         nX := nRow

         ScreenToClient( GetFormHandle( cFormName ), @nCol, @nRow )

         SetProperty( cFormName, cControlName, "Col", nCol )
         SetProperty( cFormName, cControlName, "Row", nRow )

         SbarText( "Row " + LTRIM( STR( nRow ) ) + " / " + "Col " + LTRIM( STR( nCol ) ) )
      ENDIF
      DO EVENTS
   ENDDO

*   EventRemove( nIndex )

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure SbarText()
*+
*+    Called from ( lbdd.prg )   1 - procedure movearound()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE SbarText( cText, cIcon )

LOCAL hWnd := GetControlHandle( "StatusBar", "MainForm" )

   DEFAULT cText TO ""

   DO CASE
      CASE EMPTY( cIcon )
         _SetStatusIcon( "StatusBar", "MainForm", 1, NIL )
      CASE cIcon = "STARTNOW"
         //  MainForm.StatusBar.IconHandle (1) := LOADRESOURCE(0,"ICOSEARCH")
         _SetStatusIcon( "StatusBar", "Form1_1", 1, "ICODEPART" )
   ENDCASE
   MainForm.StatusBar.Item( 1 ) := cText

RETURN

*+--------------------------------------------------------------------
*+
*+    Function SP_lLBDown()
*+
*+    Called from ( lbdd.prg )   4 - function labeleventhandler()
*+                                   1 - procedure movearound()
*+
*+--------------------------------------------------------------------
*+
FUNCTION SP_lLBDown( lValue )

STATIC lRet := .F.
   IF PCOUNT() > 0
      lRet := lValue
   ENDIF
RETURN lRet

*+ EOF: LBDD.PRG